; xchange scrren lines: A1 points to line1
; A2 points to line 2
;
* HMIRROR [xorig%,xsize%,yorig%,ysize%]

	SECTION	HMIRROR
	xdef	hmirror
	xref	scr_llen
	xref	scr_bytes
	xref	scr_base
	xref	scr_xsize
	xref	scr_ysize

err_bp	MOVEQ	#-15,D0
	RTS
hmirror	MOVE.W	scr_xsize(PC),D1
	BEQ.S	err_bp
	MOVE.W	scr_ysize(PC),D2
	BEQ.S	err_bp
	MOVE.L	scr_base(PC),A4
	CLR.L	D7
	CLR.L	D5
	MOVE.W	scr_bytes(PC),D7	; bytes per pixel
	MOVE.W	scr_llen(PC),D5	; bytes per line
	CMP.L	A3,A5
	BEQ.S	common
get_params MOVE.W	 $112,A2
	JSR	(A2)		; get ints
	TST.L	D0
	BNE.S	out
	SUBQ.W	#4,D3
	BNE.S	err_bp
	ADDQ.L	#8,$58(A6)
	MOVE.W	(A6,A1.L),D0	; xorig%
	MOVE.L	scr_base(PC),A4
	MULU	D7,D0
	ADD.L	D0,A4		; point to xorig now
	MOVE.W	4(a6,a1.L),D0	; yorig%
	MULU	D5,D0
	ADD.L	D0,A4		; point to yorig
	MOVE.W	2(A6,A1.L),D1	; xsize%
	BEQ.S	err_bp
	MOVE.W	6(A6,A1.L),D2	; ysize
	CMP.W	#1,D2
	BLE.S	out		;
common	MOVE.L	A4,A3
	MOVE.W	D2,D0		; ysize
	SUBQ.W	#1,D0
	MULU	D5,D0		; * nbr of bytes / line
	ADD.L	D0,A3		; point to last line
	MULU	D7,D1		; xsize in nbr of bytes
	LSR.W	#1,D2
	SUBQ.W	#1,D2
	MOVE.L	A4,D0
	BTST	#0,D0		; is this an odd adresse?
	BNE.S	byte		; yes, we MUST use byte moves
	BTST	#0,D5		; is line increase odd
	BNE.S	byte		; yes, we MUST use byte moves
	BTST	#0,D1
	BNE.S	byte
	BTST	#1,D1
	BNE.S	word
	LSR.W	#2,D1		; use long words
	SUBQ.W	#1,D1
	MOVE.W	D1,D7
; D7 = nbr of bytes/line
; D2 = nbr of lines to treat (2 lines at each go)
Lline_lp1 MOVE.L	A4,A1		; line 1
	MOVE.L	A3,A2		; line 2
Lpix_lp1	MOVE.L	(A1),D0		; 1rst word in line1
	MOVE.L	(A2),(A1)+
	MOVE.L	D0,(A2)+
	DBF	D1,Lpix_lp1
	MOVE.L	D7,D1
	ADD.L	D5,A4
	SUB.L	D5,A3
	DBF	D2,Lline_lp1
out	MOVEQ	#0,D0
	RTS

word	LSR.W	#1,D1
	SUBQ.W	#1,D1
	MOVE.W	D1,D7
wline_lp1 MOVE.L	A4,A1		; line 1
	MOVE.L	A3,A2		; line 2
wpix_lp1	MOVE.W	(A1),D0		; 1rst word in line1
	MOVE.W	(A2),(A1)+
	MOVE.W	D0,(A2)+
	DBF	D1,Wpix_lp1
	MOVE.L	D7,D1
	ADD.L	D5,A4
	SUB.L	D5,A3
	DBF	D2,Wline_lp1
	MOVEQ	#0,D0
	RTS



byte	SUBQ.W	#1,D1
	MOVE.W	D1,D7
bline_lp1 MOVE.L	A4,A1		; line 1
	MOVE.L	A3,A2		; line 2
bpix_lp1	MOVE.B	(A1),D0		; 1rst word in line1
	MOVE.B	(A2),(A1)+
	MOVE.B	D0,(A2)+
	DBF	D1,bpix_lp1
	MOVE.W	D7,D1
	ADD.L	D5,A4
	SUB.L	D5,A3
	DBF	D2,bline_lp1
	MOVEQ	#0,D0
	RTS

	end
