def proc set_preferences
rem v. 1.03
local res,lp%,sugg$,lp2%
  res=list_select("Preferences",preferences$,preferences%,4)
  select on res
    =1 : sugg$=""			: rem make one colour as transparent
	 rep lp%
	   sugg$=read_string$(menu_name$(res),sugg$,prompt$(res))
	   if sugg$="":do_spot%=0:mk_string none$,1:exit lp%
	   if coords_ok% (sugg$):do_spot%=1:mk_string sugg$,1:exit lp%
	   beep 1000,1000
	 end rep lp%
    =2 : sugg$=hex$(inkcol,32):sugg$=sugg$(3 to)  : rem new colour for LEDs
	 rep lp%
	   sugg$=read_string$(Menu_name$(res),sugg$,Prompt$(res),6)
	   if sugg$="":exit lp%
	   if is_hex%(sugg$):exit lp%
	 end rep lp%
	 if sugg$<>"": inkcol=hex(sugg$):display_sizes 0,0
    =3 : sugg$=spritepap$		: rem window colour
	 rep lp%
	   sugg$=read_string$(menu_name$(res),sugg$,prompt$(res))
	   if sugg$="":exit lp% 	: rem no colour given
	   if sugg$(1)="$"
	     if len(sugg$)=1
	       sugg$="" 		: rem wm colour
	       exit lp%
	     else
	       sugg$=sugg$(2 to)
	       if is_hex%(sugg$) and len(sugg$)<5:sugg$='$'&sugg$:exit lp%
	       beep 1000,1000
	       next lp%
	     end if
	   else
	     if is_hex%(sugg$):exit lp%
	     beep 1000,1000
	   endif
	 end rep lp%
	 if sugg$<>"":spritepap$=sugg$
	 show_sprite
	 preferences%(3)=0
    =5 : lp2%=timeout% div 25		: rem hint timeout
	 sugg$=lp2%			: rem suggestion
	 rep lp%
	   sugg$=read_string$(menu_name$(res),sugg$,prompt$(res)) :rem get number
	   if sugg$="":return		: rem don't do anything!
	   for lp2%=1 to len(sugg$)
	     if not sugg$(lp2%) instr '0123456789':next lp% : rem only numbers
	   end for lp2%
	   exit lp%			: rem if we come here there are only numbers
	 end rep lp%
	 res=sugg$			: rem make sure this doesn't ....
	 res=res*25			: rem (ticks)
	 if res>32000:res=32000 	: rem ... exceed an integer
	 timeout%=res
	 res=timeout% div 25
	 sugg$=res
	 if not timeout%
	    timeout%=-1 		: rem 0 for infinite timeout
	    sugg$=none$
	 endif
	 preferences%(5)=0
	 mk_string sugg$,5
    =6 : sprite_mode%=not sprite_mode%
	 if sprite_mode%
	   mk_string ("64"),6	      : rem 1 = 64
	 else
	   mk_string ("16"),6	      : rem 0 = 16
	 endif
	 preferences%(6)=0
  end select
  do_alpha%=preferences%(0)
  for lp%=1 to 2
    preferences%(lp%)=0 		 : rem reset these items to available
  end for lp%
end def set_preferences
:
def fn coords_ok%(sugg$)
rem check that the coords are ok, return 1 if yes, 0 if not
local a$,lp%,llen%,count%,start%
rem get the first coord
  a$=strip_spaces$(sugg$)
  llen%=len(a$)
  if not llen%:ret 0			: rem empty string
  t%=" " instr a$
  if not t%:ret 0			: rem no space between coords
  b$=a$(1 to t%-1)
  a$=strip_spaces$(a$(t% to))
  llen%=len(b$)
  if (not llen%) or (llen%>5):ret 0		       : rem what, 0 length number?
  for lp%=1 to llen%
    if not b$(lp%) instr "0123456789":ret 0 : rem it MUST be a number
  end for lp%
  llen%=len(a$)
  if (not llen%) or llen%>5:ret 0
  for lp%=1 to llen%
    if not a$(lp%) instr "0123456789":ret 0
  end for lp%
  spotx%=b$:spoty%=a$
  do_spot%=1
  return 1
end def coords_ok%
:
def fn is_hex%(sugg$)
rem returns 1 if string is legitimate hex
local ll%,lp%
  ll%=len(sugg$)
  if not ll%:ret 0
  for lp%=1 to ll%
    if not sugg$(lp%) instr "0123456789abcdef":return 0
  end for lp%
  return 1
end def is_hex
:
