*** part of npand_s :  handles Lword sized shifts
*** simply converted from word sized shifts


	section dlshifts



	xdef	dluleft
	xdef	dluright
	xdef	dldleft
	xdef	dldright



quit1	RTS
; rem pan up and left



; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = xstep% in bytes
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = ysize% | xsize% in bytes



; now save the 1rst part of the screen (upper part) to the buffer
; we have to save the entire width of the window, ystep% lines deep.

dluleft	LSR.W	#2,D6		; in Lwords
	LSR.W	#2,D3		; in Lwords
	MOVE.W	D6,D1		; xsize% in Lwords
	SWAP	D6		; xsize% in Lwords | ysize%
	SUBQ.W	#1,D1
	MOVE.L	A5,A1
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.L	A0,A3
line_lp1	MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp1	MOVE.L	(A2)+,(A3)+	; copy Lwords accross
	DBF	D0,pix_lp1
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp1	; do for all lines in step
; now save the second part (left part) of the "wdw" to the buffer
; we have to save xstep% bytes for ysze%-ystep% lines, starting at (0,ystep%)
; D3 = ???? | xstep% in Lwords
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in Lwords) | ysize%

	MOVE.L	A5,A1		; "wdw" origin
	MOVE.W	D5,D0		; ystep%
	MULU	D4,D0		;
	ADD.L	D0,A1		; point to start of what we need to save
	MOVE.W	(A7),D7		; ysize% -ystep%
	SUBQ.W	#1,D7		; for DBF
	MOVE.L	A1,-(A7)
	MOVE.W	D3,D1		; xtep% in Lwords
	SUBQ.W	#1,D1		; DBF
line_lp2	MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp2	MOVE.L	(A2)+,(A3)+	; copy Lwords accross
	DBF	D0,pix_lp2
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp2	; do for all lines in "wdw" - step
; now copy each line up & left
	MOVE.L	(A7)+,A1		; wdw  orig (+ystep%)
	MOVE.W	(A7),D7		; the is the line counter: ysize-ystep
	SUBQ.W	#1,D7
	MOVE.W	D3,D0
;
	LSL.W	#2,D0		; xstep% in bytes
;
	ADD.W	D0,A1		; this is the start from where we copy
	MOVE.W	2(A7),D1		; xsize%-xstep% in bytes
;
	LSR.W	#2,D1		; in Lwords
;
	SUBQ.W	#1,D1		; nbr of pixels (Lwords) to copy per line
	MOVE.L	A5,-(A7)		; keep
line_lp3	MOVE.L	A5,A2		; target
	MOVE.L	A1,A3		; source
	MOVE.W	D1,D0		; nbr of word to copy per line
pix_lp3	MOVE.L	(A3)+,(A2)+	; copy Lwords accross for one line
	DBF	D0,pix_lp3
	ADD.L	D4,A1		; point to next source line
	ADD.L	D4,A5		; point to next target line
	DBF	D7,line_lp3	; do for all lines in "wdw" - step
; now copy back from the buffer
; first the part that was at the upper left corner and is now at the lower right corner
	MOVE.L	(A7)+,A5		; point to wdw "origin"
	MOVE.L	A5,A1		; same
	MOVE.W	(A7),D0		; ysize%-ystep%
	MULU	D4,D0		; * nbr bytes per line
	ADD.L	D0,A1		; point to yorig% + ysize% -ystep% OK
	MOVE.W	2(A7),D0		; xsize% - xstep% in Lwords
	MOVEM.L	D5/A5,-(A7)	; keep these

	MOVE.W	D3,D1		; xstep% in Lwords
	SUBQ.W	#1,D1		; nbr of Lwords to copy per line
			
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.W	D0,D5		, xsize%- xstep% in bytes
;
	LSR.W	#2,D5		; now in Lwords
;
	SUBQ.W	#1,D5		; second counter (xsize%-xstep%)
	MOVE.L	A1,A3		; point to this origin now (lower left)
	ADD.W	D0,A1		; xorig of place where this goes (lower right)
	MOVE.L	A0,A5		; source
; a1 = lower right, A3 = lower left
line_lp4	MOVE.L	A1,A2		; target line
	MOVE.W	D1,D0
pix_lp4	MOVE.l	(A5)+,(A2)+	; copy source to target (lower right)
	DBF	D0,pix_lp4
	MOVE.W	D5,D0
	MOVE.L	A3,A2		; target line (lower left)
pix_lp5	MOVE.l	(A5)+,(A2)+	; now copy to lower left
	DBF	D0,pix_lp5
	ADD.L	D4,A3
	ADD.L	D4,A1
	DBF	D7,line_lp4
	MOVE.L	A5,A2		; keep pointer to source
	MOVEM.L	(A7)+,D5/A5
; D3 = ???? | xstep% (in Lwords)
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in Lwords) | ysize%
; A3 now points to the first new screen data in buffer
	MOVE.W	2(A7),D0		; xsize%-xstep%
	ADD.W	D0,A5		; point to new xorigin
	SUBQ.W	#1,D3
	MOVE.W	(A7)+,D1		; ysize% - ystep%
	ADDQ.L	#2,A7
	SUBQ.W	#1,D1
line_lp6	MOVE.L	A5,A1		; point to target
	MOVE.W	D3,D0
pix_lp6	MOVE.l	(A2)+,(A1)+
	DBF	D0,pix_lp6
	ADD.L	D4,A5
	DBF	D1,line_lp6
	CLR.L	D0
	TST.L	D2
	BNE.S	out1
	MOVEQ	#$19,D0
	TRAP	#1
out1	RTS


; now we're panning up right
; now save the 1rst part of the screen (upper part) to the buffer
; we have to save the entire width of the window, ystep% lines deep.
dluright	LSR.W	#2,D6		; in Lwords
	LSR.W	#2,D3		; in Lwords
	MOVE.L	D6,D1		; xsize% in Lwords
	SWAP	D6
	SUBQ.W	#1,D1
	MOVE.L	A5,A1
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.L	A0,A3
line_lp7	MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp7	MOVE.L	(A2)+,(A3)+	; copy Lwords accross
	DBF	D0,pix_lp7
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp7	; do for all lines in step
; now save the second part (right part) of the "wdw" to the buffer
; we have to save xstep% bytes for ysze%-ystep% lines, starting at (0,ystep%)
; D3 = ???? | xstep% in Lwords
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in Lwords) | ysize%

	MOVE.L	A5,A1		; "wdw" origin
	MOVE.W	D5,D0		; ystep%
	MULU	D4,D0		;
	ADD.L	D0,A1		; point to start of what we need to save
	MOVE.W	(A7),D7		; ysize% -ystep%
	SUBQ.W	#1,D7		; for DBF
	MOVE.W	2(A7),D0		; xsize%-xstep% in bytes
	MOVE.L	A1,-(A7)		; keep
	ADD.W	D0,A1		; point to new x origin
	MOVE.W	D3,D1		; xtep% in Lwords
	SUBQ.W	#1,D1		; DBF
line_lp8	MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp8	MOVE.L	(A2)+,(A3)+	; copy Lwords accross
	DBF	D0,pix_lp8
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp8	; do for all lines in "wdw" - step
; now copy each line up & right
	MOVE.L	(A7)+,A1		; wdw  orig (+ystep%)
	MOVE.W	(A7),D7		; line counter: ysize%-ystep%
	SUBQ.W	#1,D7
	MOVE.W	D3,D0
;
	LSL.W	#2,D0		; xstep% in bytes
;
	MOVE.W	2(A7),D1		; xsize%-xstep% in bytess
;
	LSR.W	#2,D1		; now in Lwords
;
	SUBQ.W	#1,D1		; nbr of pixels (Lwords) to copy per line
	MOVE.L	A5,-(A7)		; keep
	ADD.W	D0,A5		; this is the start to where we copy
line_lp9	MOVE.L	A5,A2		; target
	MOVE.L	A1,A3		; source
	MOVE.W	D1,D0		; nbr of word to copy per line
pix_lp9	MOVE.L	(A3)+,(A2)+	; copy Lwords accross for one line
	DBF	D0,pix_lp9
	ADD.L	D4,A1		; point to next source line
	ADD.L	D4,A5		; point to next target line
	DBF	D7,line_lp9	; do for all lines in "wdw" - step
; now copy back from the buffer
; first the part that was at the upper left corner and is now at the lower right corner
	MOVE.L	(A7)+,A5		; point to wdw "origin"
	MOVE.L	A5,A1		; same
	MOVE.W	(A7),D0		; ysize%-ystep%
	MULU	D4,D0		; * nbr bytes per line
	ADD.L	D0,A1		; point to yorig% + ysize% -ystep% OK
	MOVE.W	2(A7),D0		; xsize% - xstep% in Lwords
	MOVEM.L	D5/A5,-(A7)	; keep these

	MOVE.W	D3,D1		; xstep% in Lwords
	SUBQ.W	#1,D1		; nbr of Lwords to copy per line
			
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.W	D0,D5		, xsize%- xstep% in bytes
;
	LSR.W	#2,D5		; now in Lwords
;
	SUBQ.W	#1,D5		; second counter (xsize%-xstep%)
	MOVE.L	A1,A3		; point to this origin now (lower left)
	ADD.W	D0,A1		; xorig of place where this goes (lower right)
	MOVE.L	A0,A5		; source
; a1 = lower right, A3 = lower left
line_lp10 MOVE.L	A3,A2		; target line
	MOVE.W	D5,D0
pix_lp10	MOVE.L	(A5)+,(A2)+	; copy source to target (lower right)
	DBF	D0,pix_lp10
	MOVE.W	D1,D0
	MOVE.L	A1,A2		; target line (lower left)
pix_lp11	MOVE.L	(A5)+,(A2)+	; now copy to lower left
	DBF	D0,pix_lp11
	ADD.L	D4,A3
	ADD.L	D4,A1
	DBF	D7,line_lp10
	MOVE.L	A5,A2		; keep pointer to source
	MOVEM.L	(A7)+,D5/A5
; D3 = ???? | xstep% (in Lwords)
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in Lwords) | ysize%
; A3 now points to the first new screen data in buffer
	SUBQ.W	#1,D3
	MOVE.W	(A7)+,D1		; ysize% - ystep%
	ADDQ.L	#2,A7
	SUBQ.W	#1,D1
line_lp12 MOVE.L	A5,A1		; point to target
	MOVE.W	D3,D0
pix_lp12	MOVE.L	(A2)+,(A1)+
	DBF	D0,pix_lp12
	ADD.L	D4,A5
	DBF	D1,line_lp12
	CLR.L	D0
	TST.L	D2
	BNE.S	out2
	MOVEQ	#$19,D0
	TRAP	#1
out2	RTS

; diagonal pan down left
dldleft	LSR.W	#2,D6		; in Lwords
	LSR.W	#2,D3		; in Lwords
	MOVE.W	D6,D1		; xsize% in Lwords
	SWAP	D6		; xsize% in Lwords | ysize%
	SUBQ.W	#1,D1
	MOVE.L	A5,A1
	MOVE.W	(A7),D0
	MULU	D4,D0
	ADD.L	D0,A1		; point to origin of block to save
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.L	A0,A3
line_lp13 MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp13	MOVE.L	(A2)+,(A3)+	; copy Lwords accross
	DBF	D0,pix_lp13
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp13	 ; do for all lines in step
; now save the second part (left part) of the "wdw" to the buffer
; we have to save xstep% bytes for ysze%-ystep% lines, starting at (0,ystep%)
; D3 = ???? | xstep% in Lwords
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in Lwords) | ysize%

	MOVE.L	A5,A1		; "wdw" origin
	MOVE.W	(A7),D7		; ysize% -ystep%
	SUBQ.W	#1,D7		; for DBF
	MOVE.W	D3,D1		; xtep% in Lwords
	SUBQ.W	#1,D1		; DBF
line_lp14 MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp14	MOVE.L	(A2)+,(A3)+	; copy Lwords accross
	DBF	D0,pix_lp14
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp14	 ; do for all lines in "wdw" - step
; now copy each line down & left
	MOVE.W	(A7),D7		; the is the line counter: ysize-ystep
	SUBQ.W	#1,D7		; line counter
	MOVE.W	2(A7),D1		; xsize%-xstep% in bytes
;
	LSR.W	#2,D1		; in Lwords
;
	SUBQ.W	#1,D1		; nbr of pixels (Lwords) to copy per line
	MOVE.L	A5,-(A7)		; keep
	MOVE.W	D6,D0
	SUBQ.W	#1,D0
	MULU	D4,D0
	ADD.L	D0,A5		; point to first target
	MOVE.L	A5,A1		; point wdw orig
	MOVE.W	D3,D0		; xstep% in Lwords%
;
	LSL.W	#2,D0		; xstep% in bytes
;
	ADD.W	D0,A1		; this is the start from where we copy
	MOVE.W	D5,D0		; ystep%
	MULU	D4,D0		: now in bytes
	SUB.L	D0,A1		; this is the source

line_lp15 MOVE.L	A5,A2		; target
	MOVE.L	A1,A3		; source
	MOVE.W	D1,D0		; nbr of word to copy per line
pix_lp15	MOVE.L	(A3)+,(A2)+	; copy Lwords accross for one line
	DBF	D0,pix_lp15
	SUB.L	D4,A1		; point to next source line
	SUB.L	D4,A5		; point to next target line
	DBF	D7,line_lp15	 ; do for all lines in "wdw" - step
; now copy back from the buffer
; first the part that was at the upper left corner and is now at the lower right corner
	MOVE.L	(A7)+,A5		; point to wdw "origin"
	MOVE.L	A5,A1		; same
	MOVE.W	2(A7),D0		; xsize% - xstep% in Lwords
	MOVEM.L	D5/A5,-(A7)	; keep these

	MOVE.W	D3,D1		; xstep% in Lwords
	SUBQ.W	#1,D1		; nbr of Lwords to copy per line
			
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.W	D0,D5		, xsize%- xstep% in bytes
;
	LSR.W	#2,D5		; now in Lwords
;
	SUBQ.W	#1,D5		; second counter (xsize%-xstep%)
	MOVE.L	A1,A3		; point to this origin now (lower left)
	ADD.W	D0,A1		; xorig of place where this goes (lower right)
	MOVE.L	A0,A5		; source
; a1 = upper right, A3 = upper left
line_lp16 MOVE.L	A1,A2		; target line
	MOVE.W	D1,D0
pix_lp16	MOVE.L	(A5)+,(A2)+	; copy source to target (lower right)
	DBF	D0,pix_lp16
	MOVE.W	D5,D0
	MOVE.L	A3,A2		; target line (lower left)
pix_lp17	MOVE.L	(A5)+,(A2)+	; now copy to lower left
	DBF	D0,pix_lp17
	ADD.L	D4,A3
	ADD.L	D4,A1
	DBF	D7,line_lp16
	MOVE.L	A5,A2		; keep pointer to source
	MOVEM.L	(A7)+,D5/A5
; D3 = ???? | xstep% (in Lwords)
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in Lwords) | ysize%
; A3 now points to the first new screen data in buffer
	MOVE.W	2(A7),D0		; xsize%-xstep%
	ADD.W	D0,A5		; point to new xorigin
	MOVE.W	D5,D0
	MULU	D4,D0
	ADD.L	D0,A5
	SUBQ.W	#1,D3
	MOVE.W	(A7)+,D1		; ysize% - ystep%
	ADDQ.L	#2,A7
	SUBQ.W	#1,D1
line_lp18 MOVE.L	A5,A1		; point to target
	MOVE.W	D3,D0
pix_lp18	MOVE.L	(A2)+,(A1)+
	DBF	D0,pix_lp18
	ADD.L	D4,A5
	DBF	D1,line_lp18
	CLR.L	D0
	TST.L	D2
	BNE.S	out3
	MOVEQ	#$19,D0
	TRAP	#1
out3	RTS


; now we're panning down right
; now save the 1rst part of the screen (upper part) to the buffer
; we have to save the entire width of the window, ystep% lines deep.
dldright	LSR.W	#2,D6		; in Lwords
	LSR.W	#2,D3		; in Lwords
	MOVE.L	D6,D1		; xsize% in Lwords
	SWAP	D6
	SUBQ.W	#1,D1
	MOVE.L	A5,A1

	MOVE.W	(A7),D0		; ysize% - ystep%
	MULU	D4,D0
	ADD.L	D0,A1		; point to origin of block to save
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.L	A0,A3
line_lp19 MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp19	MOVE.L	(A2)+,(A3)+	; copy Lwords accross
	DBF	D0,pix_lp19
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp19	; do for all lines in step
; now save the second part (right part) of the "wdw" to the buffer
; we have to save xstep% bytes for ysze%-ystep% lines, starting at (0,ystep%)
; D3 = ???? | xstep% in Lwords
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in Lwords) | ysize%

	MOVE.L	A5,A1		; "wdw" origin
	MOVE.W	2(A7),D0
	ADD.W	D0,A1
	MOVE.W	(A7),D7		; ysize% -ystep%
	SUBQ.W	#1,D7		; for DBF
	MOVE.W	D3,D1		; xtep% in Lwords
	SUBQ.W	#1,D1		; DBF
line_lp20 MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp20	MOVE.L	(A2)+,(A3)+	; copy Lwords accross
	DBF	D0,pix_lp20
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp20	 ; do for all lines in "wdw" - step
; now copy each line down & right
	MOVE.W	(A7),D7		; line counter: ysize%-ystep%
	SUBQ.W	#1,D7
	MOVE.W	D3,D0		; xstep% in Lwords
;
	LSL.W	#2,D0		; xstep% in bytes
;
	MOVE.W	2(A7),D1		; xsize%-xstep% in bytes
;
	LSR.W	#2,D1		; now in Lwords
;
	SUBQ.W	#1,D1		; nbr of pixels (Lwords) to copy per line

	MOVE.L	A5,-(A7)		; keep
	MOVE.W	D6,D0
	SUBQ.W	#1,D0
	MULU	D4,D0
	ADD.L	D0,A5		; point to first target
	MOVE.L	A5,A1		; point wdw orig
	MOVE.W	D3,D0		; xstep% in Lwords%
;
	LSL.W	#2,D0		; xstep% in bytes
;
	ADD.W	D0,A5		; this is the start to where we copy
	MOVE.W	D5,D0		; ystep%
	MULU	D4,D0		: now in bytes
	SUB.L	D0,A1		; this is the source
		

line_lp21 MOVE.L	A5,A2		; target
	MOVE.L	A1,A3		; source
	MOVE.W	D1,D0		; nbr of word to copy per line
pix_lp21	MOVE.L	(A3)+,(A2)+	; copy Lwords accross for one line
	DBF	D0,pix_lp21
	SUB.L	D4,A1		; point to next source line
	SUB.L	D4,A5		; point to next target line
	DBF	D7,line_lp21	; do for all lines in "wdw" - step
; now copy back from the buffer
; first the part that was at the upper left corner and is now at the lower right corner
	MOVE.L	(A7)+,A5		; point to wdw "origin"
	MOVE.L	A5,A1		; same
	MOVE.W	2(A7),D0		; xsize% - xstep% in Lwords
	MOVEM.L	D5/A5,-(A7)	; keep these

	MOVE.W	D3,D1		; xstep% in Lwords
	SUBQ.W	#1,D1		; nbr of Lwords to copy per line
			
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.W	D0,D5		, xsize%- xstep% in bytes
;
	LSR.W	#2,D5		; now in Lwords
;
	SUBQ.W	#1,D5		; second counter (xsize%-xstep%)
	MOVE.L	A1,A3		; point to this origin now (lower left)
	ADD.W	D0,A1		; xorig of place where this goes (lower right)
	MOVE.L	A0,A5		; source
; a1 = lower right, A3 = lower left
line_lp22 MOVE.L	A3,A2		; target line
	MOVE.W	D5,D0
pix_lp22	MOVE.L	(A5)+,(A2)+	; copy source to target (lower right)
	DBF	D0,pix_lp22
	MOVE.W	D1,D0
	MOVE.L	A1,A2		; target line (lower left)
pix_lp23	MOVE.L	(A5)+,(A2)+	; now copy to lower left
	DBF	D0,pix_lp23
	ADD.L	D4,A3
	ADD.L	D4,A1
	DBF	D7,line_lp22
	MOVE.L	A5,A2		; keep pointer to source
	MOVEM.L	(A7)+,D5/A5
; D3 = ???? | xstep% (in Lwords)
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in Lwords) | ysize%
; A3 now points to the first new screen data in buffer
	SUBQ.W	#1,D3
	MOVE.W	(A7)+,D1		; ysize% - ystep%
	ADDQ.L	#2,A7
	SUBQ.W	#1,D1
	MULU	D4,D5
	ADD.L	D5,A5
line_lp24 MOVE.L	A5,A1		; point to target
	MOVE.W	D3,D0
pix_lp24	MOVE.L	(A2)+,(A1)+
	DBF	D0,pix_lp24
	ADD.L	D4,A5
	DBF	D1,line_lp24
	CLR.L	D0
	TST.L	D2
	BNE.S	out4
	MOVEQ	#$19,D0
	TRAP	#1
out4	RTS



	end
