* VMIRROR [xorig%,xsize%,yorig%,ysize%]

	SECTION	vMIRROR
	xdef	vmirror
	xref	scr_llen
	xref	scr_bytes
	xref	scr_base
	xref	scr_xsize
	xref	scr_ysize

err_bp	MOVEQ	#-15,D0
	RTS
vmirror	MOVE.W	scr_xsize(PC),D1
	BEQ.S	err_bp
	MOVE.W	scr_ysize(PC),D2
	BEQ.S	err_bp
	MOVE.L	scr_base(PC),A4
	CLR.L	D7
	CLR.L	D5
	MOVE.W	scr_bytes(PC),D7	; bytes per pixel
	MOVE.W	scr_llen(PC),D5	; bytes per line
	CMP.L	A3,A5
	BEQ.S	common
get_params MOVE.W	 $112,A2
	JSR	(A2)		; get ints
	TST.L	D0
	BNE.S	out
	SUBQ.W	#4,D3
	BNE.S	err_bp
	ADDQ.L	#8,$58(A6)
	MOVE.W	(A6,A1.L),D0	; xorig%
	MOVE.L	scr_base(PC),A4
	MULU	D7,D0
	ADD.L	D0,A4		; point to xorig now
	MOVE.W	4(a6,a1.L),D0	; yorig%
	MULU	D5,D0
	ADD.L	D0,A4		; point to yorig
	MOVE.W	2(A6,A1.L),D1	; xsize%
	MOVE.W	6(A6,A1.L),D2	; ysize%
common	MOVE.L	A4,A3		; keep orig
	MOVE.W	D1,D3
	SUBQ.W	#1,D3
	MULU	D7,D3

	ADD.L	D3,A3		; point to end of window
	SUBQ.W	#1,D2		; line counter
	BLE.S	out
	LSR.W	#1,D1
	BEQ.S	out		; width counter
	SUBQ.W	#1,D7
	BEQ.S	bytes
	SUBQ.W	#1,D7
	BEQ.S	words
	SUBQ.W	#1,D7
	BEQ.S	triples
Lwords	MOVE.L	A4,A1
	MOVE.L	A3,A2
	MOVE.W	D2,D3
Ly_lp	MOVE.L	(A2),D0
	MOVE.L	(A1),(A2)
	MOVE.L	D0,(A1)
	ADD.L	D5,A1		; point to next line
	ADD.L	D5,A2
	DBF	D3,Ly_lp
	ADDQ.L	#4,A4
	SUBQ.L	#4,A3
	DBF	D1,lwords
out	MOVEQ	#0,D0
	RTS

bytes	MOVE.L	A4,A1
	MOVE.L	A3,A2
	MOVE.W	D2,D3
y_lp	MOVE.B	(A2),D0
	MOVE.B	(A1),(A2)
	MOVE.B	D0,(A1)
	ADD.L	D5,A2		; point to next line
	ADD.L	D5,A1
	DBF	D3,y_lp
	ADDQ.L	#1,A4
	SUBQ.L	#1,A3
	DBF	D1,bytes
	MOVEQ	#0,D0
	RTS

words	MOVE.L	A4,A1
	MOVE.L	A3,A2
	MOVE.W	D2,D3
wy_lp	MOVE.W	(A2),D0
	MOVE.W	(A1),(A2)
	MOVE.W	D0,(A1)
	ADD.L	D5,A2		; point to next line
	ADD.L	D5,A1
	DBF	D3,wy_lp
	ADDQ.L	#2,A4
	SUBQ.L	#2,A3
	DBF	D1,words
	MOVEQ	#0,D0
	RTS

	

triples	MOVE.L	A4,A1
	MOVE.L	A3,A2
	MOVE.W	D2,D3
ty_lp	MOVE.B	(A2),D0
	MOVE.B	(A1),(A2)
	MOVE.B	D0,(A1)
	MOVE.B	1(A2),D0
	MOVE.B	1(A1),1(A2)
	MOVE.B	D0,1(A1)
	MOVE.B	2(A2),D0
	MOVE.B	2(A1),2(A2)
	MOVE.B	D0,2(A1)
	ADD.L	D5,A2		; point to next line
	ADD.L	D5,A1
	DBF	D3,ty_lp
	ADDQ.L	#3,A4
	SUBQ.L	#3,A3
	DBF	D1,bytes
	MOVEQ	#0,D0
	RTS

	
	end
