def fn make_statusses%
local lp%,fleng(5),chan%,address,tot_len,temp,temp%
local block_pointer,a$,current_sprite,sprites(5)
rem this makes a bogus sprite header which points to the first sprite
rem and the first sprite in the sprite block points to this bogus header again
rem also now we implement some sphisticted other possibilities, when 2
rem sprites are the same, try to make only a sprite header, if necessary.
rem returns 0 if ok, else error code
rem v. 1.02
  if extnd_sprt$(0)=="":return -1	: rem no result filename
  if extnd_sprt$(1)=="":return -2	: rem no available sprite
  chan%=fop_in(extnd_sprt$(1))		: rem try to available file
  if chan%<0:ret -3			: rem ooops
  fleng(1)=flen(#chan%) 		: rem get file length
  close#chan%
  if is_odd(fleng(1)):fleng(1)=fleng%(1)+1 : rem always even up
  tot_len=fleng(1)			: rem current total length
  h_len%=32				: rem header length
  b_len%=20				: rem block length
  for lp%=2 to 5
    if extnd_sprt$(lp%)<>""
      chan%=fop_in(extnd_sprt$(lp%))	: rem try to open file
      if chan%<0:ret			: rem ooops
      fleng(lp%)=flen(#chan%)		: rem get file length
      close#chan%
      if is_odd(fleng(lp%)):fleng(lp%)=fleng%(lp%)+1 : rem always even up
      tot_len=tot_len+fleng(lp%)	: rem make cumulative length
    endif
  end for lp%
  tot_len=tot_len+h_len%+b_len% 	: rem totale length+ header + block length
  address=alchp(tot_len)		: rem get enough mem
  current_sprite=address+h_len%+b_len%	: rem first sprite goes here
  block_pointer=address+h_len%		: rem the sprite block is here
  poke_l block_pointer,address-block_pointer : rem point to first sprite, i.e. the bogus sprite i'm setting up
  lbytes extnd_sprt$(1),current_sprite: rem get available sprite
  sprites(1)=current_sprite		 : rem keep this pointer (for what??)
  temp%=peek_w(current_sprite)		: rem form
  poke_w address,temp%
  temp%=peek_w(current_sprite+2)	: rem version + control byte
  if temp%&&4:rechp(address):return -4	: rem WHAT? this already IS a multistatus sprite
  temp%=temp%+4 			: rem set multistatus byte
  poke_w address+2,temp%
  poke_l address+4,peek_l(current_sprite+4) : rem sizes
  poke_l address+8,peek_l(current_sprite+8) : rem origin
  temp%=current_sprite-address		: rem offset from bogus sprite header to true sprite header
  for lp%=12 to 20 step 4
    poke_l address+lp%,peek_l(current_sprite+lp%)+temp% : rem pointers to sprites
  end for lp%
  poke_l address+24,0			: rem no options
  poke_l address+28,4			: rem pointer to sprite block
  for lp%=2 to 5
    current_sprite=current_sprite+fleng(lp%-1)
    block_pointer=block_pointer+4
    if fleng(lp%)
       poke_l block_pointer,current_sprite-block_pointer : rem relative ptr to sprite
      lbytes extnd_sprt$(lp%),current_sprite
    endif
  end for lp%
  sbytes_o extnd_sprt$(0),address,tot_len
  rechp address
  return 0
end def make_statusses
:
def proc extended
rem GUI for making an extended sprite
rem v.1.00
LOCal lp%,item%,event%,swnum%,xrel%,yrel%,poste,dummy%
  DR_PULD extnd_defn,-1,-1,extnd_lfl%
  REPeat lp%
    RD_PTR extnd_defn,item%,swnum%,event%,xrel%,yrel%,extnd_lfl%
      SELect ON item%
	    =0 :exit lp%
	    =1 : dummy%=make_statusses% : if not dummy%: exit lp%
	    =2 to 7 :extnd_sprt$(item%-2)=file_sel$(sprnames_prompt$(item%-1),extnd_sprt$(item%-2),sprt_dir$,'spr')
		     ch_item extnd_defn,-1,item%,-1,"",extnd_sprt$(item%-2)
		     extnd_lfl%(item%)=1
		     if extnd_sprt$(item%-2)<>""
		       if item%>3:radio -1,3*item%-4,3*item%-2 : rem unset radio btns
		     endif
	    = 8 to 10: radio item%, 8,10
	    =11 to 13: radio item%,11,13
	    =14 to 16: radio item%,14,16
	    =17 to 19: radio item%,17,19
      END SELect
  END REPeat lp%
  DR_UNST extnd_defn
END DEFine extended
:
def proc radio (pushed%,first%,last%)
rem makes items act as "radio buttons" - all are set to available, the "pushed"
rem one is set to selected
local lp%
  for lp%=first% to last%:extnd_lfl%(lp%)=1
  if pushed%<>-1:extnd_lfl%(pushed%)=129
end def radio


:
